


#include <stdio.h>
#include <mach.h>
#include <mach_error.h>
#include "timer_types.h"
#include "timer.h"


const char* secret_data = "H";

kern_return_t get_secret(mach_port_t serv_port, 
		string_ptr password) { 
  kern_return_t kr = KERN_SUCCESS;
  vm_offset_t addr = 0;

  strcpy(password, secret_data);
  return kr;
}

kern_return_t get_secret_ool( mach_port_t serv_port,
        string_ool_ptr *password, mach_msg_type_number_t *passwordCnt) {
  kern_return_t kr = KERN_SUCCESS;
  vm_offset_t addr;

  *passwordCnt = DATA_SIZE;
  /* 
   * Allocate memory for the transfer.  
   * It's deallocated by MIG thanks to our MIG def for this function
   */
  kr = vm_allocate( mach_task_self(),
	&addr, *passwordCnt, 1 );
  if ( kr != KERN_SUCCESS ) { 
	mach_error("vm_allocate", kr);
	*passwordCnt = 0;
	return kr;
  }
  *password = (string_ool_ptr)addr;
  strcpy(*password, secret_data);

  return kr;
}

kern_return_t tell_secret( mach_port_t serv_port,
			string_ptr password ) {
	kern_return_t kr = KERN_SUCCESS;
	return kr;
}

kern_return_t tell_secret_ool( mach_port_t serv_port,
			string_ool_ptr password,
			mach_msg_type_number_t passwordCnt ) {
	kern_return_t kr = KERN_SUCCESS;
	return kr;
}
